#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "jetzt.c"

void fatal ( char *comment ) {
	perror(comment);
	exit(0);
}

int main ( int ac, char **av ) {

	if (ac != 3) {
		fprintf(stderr,"usage: %s <port> <maxbuf>\n",av[0]);
		exit(0);
	}

	int port = atol(av[1]);
	long maxbuf = atol(av[2]);

	// Socket erzeugen
	int s = socket(AF_INET,SOCK_STREAM,0);
	if (s == -1) fatal("socket");

	// Socket an gewuenschten Port fest binden
	struct sockaddr_in addr;
	memset((char *) &addr,0,sizeof(addr));
	addr.sin_family = PF_INET;
	unsigned long inaddr_any = INADDR_ANY;
	memcpy(&(addr.sin_addr),&inaddr_any,sizeof(addr.sin_addr));
	addr.sin_port = htons(port);
	int ret = bind(s,(struct sockaddr *) &addr, sizeof(addr));
	if (ret == -1) fatal("bind");
	ret = listen(s,2);
	
	printf("Warte auf Connects an Port 4211 ...\n");

	// Hinreichend grossen Puffer bereitstellen
	char *buffer = new char[maxbuf];
	if (buffer == 0) fatal("new");

	int ns = accept(s,NULL,0);
	if (ns == -1) fatal("accept");

	double anfang = jetzt();
	int nbytes_gesamt = 0;
	while (1) {
		int nbytes = read(ns,buffer,maxbuf);
		if (nbytes == -1) fatal("read");
		if (nbytes == 0) break;
		nbytes_gesamt += nbytes;
	}
	double ende = jetzt();
	printf("%ld B, %lf ms\n",nbytes_gesamt,ende-anfang);
	printf("%lf MB/s\n",1000.0 * ((double) nbytes_gesamt) / (ende-anfang) / 1024.0 / 1024.0 );

	close(ns);
	close(s);
}



