#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

void fatal ( char *comment ) {
	perror(comment);
	exit(0);
}

#include "jetzt.c"

volatile long dummy = 0;

int main ( int ac, char **av ) {
	// Argumente lesen
	if (ac != 6) {
		fprintf(stderr,"usage: %s <host> <port> <secs> <period_usec> <gran>\n",av[0]);
		exit(0);
	}
	char *host = av[1];
	long port = atol(av[2]);
	double msecs = atof(av[3]) * 1000.0;
	double period = 0.001 * atof(av[4]);
	long gran = atol(av[5]);

 	// Socket erzeugen
	int s = socket(PF_INET,SOCK_STREAM,0);
	if (s == -1) fatal("socket");

	struct sockaddr_in addr;
	memset((char *) &addr,0,sizeof(addr));
	addr.sin_family = PF_INET;
        struct hostent *he = gethostbyname(host);
        if (he == 0) fatal("gethostbyname");
        memcpy(&(addr.sin_addr),he->h_addr_list[0],sizeof(struct in_addr));
        addr.sin_port = htons(port);                                           	unsigned long inaddr_any = INADDR_ANY;
	
	// Hinreichend grossen Puffer bereitstellen
	char *buffer = new char[gran];
	for (int i=0; i<gran; i++) buffer[i] = i % 256;

	connect(s,(struct sockaddr *) &addr,sizeof(addr));
	long nbytes_gesamt = 0;
	double anfang = jetzt();
	double ende;
	double t1;
	do {
		t1 = jetzt();
		int ret = write(s,buffer,gran);
 		if (ret == -1) fatal("sendto");
		nbytes_gesamt += ret;
		printf("%lf %ld\n",t1-anfang,nbytes_gesamt);
		ende = jetzt();
		while (jetzt()-ende <= period) {
			 dummy++;
			printf("%lf %ld\n",jetzt()-anfang,nbytes_gesamt);
		};
	} while (ende - anfang <= msecs);
	close(s);

	printf("# %lf MB/s\n",1000.0 * nbytes_gesamt / ( ende-anfang) / 1024.0 / 1024.0 );
}




